/**
 * @Author: wzy
 * @Date: 2021-11-19
 * @LastEditTime: 
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @filePath:
 */

#pragma once

#include <iostream>
#include <vector>

#include "PD_EgoVehStsArb.h"
#include "PD_DynamicObjRisk.h"

namespace ADC
{
namespace PD_TrffcEffcy
{

class TrffcEffcy
{
public:
    TrffcEffcy(const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list);
    ~TrffcEffcy() = default;

private:
    bool init(const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list);
    bool initFlag = true;

/**
  * @brief   Calculate the  distance of endnode
  * @param   
  * @return  the  distance of node
  */
    float CalculateEffLongDrvDis();

/**
  * @brief   Calculate the speed of endnode
  * @param   
  * @return  the speed of node
  */
    float CalculateEffEndSpd();

/**
  * @brief   Calculate the average speed during node
  * @param   
  * @return  the average speed during node
  */
    float CalculateEffAvgSpd();

private:
    std::vector<ADC::PD_DynmcObjRsk::EgoVeh_Point> _egoVeh_TrjPnt;

public:
    void process();
    float m_EffLongDrvDis = 0.0f;      //纵向行驶距离
    float m_EffEndSpd = 0.0f;          //节点结束车速
    float m_EffAvgSpd = 0.0f;          //节点平均车速
};



}   //namespace PD_TrffcEffcy
}   //namespace ADC